> For the complete documentation index, see [llms.txt](https://docs.balena.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.balena.io/learn/more/examples/balenablocks.md).

# balenaBlocks built for balenaCloud

balenaBlocks are pre-built container images which developers can add to their multicontainer apps to provide useful functionality. Their aim is to reduce the friction of creating IoT applications which enables rapid prototyping and development. These intelligent, drop-in chunks of functionality are built to handle the basics, allows you as developers to focus on solving the hard problems. You can read more about balenaBlocks on our [blog](https://www.balena.io/blog/introducing-balenablocks-jumpstart-your-iot-app-development/).

Checkout [balenaBlocks](/learn/develop/blocks.md) docs to build & publish your first block on balenaHub. To find the complete list of available blocks to try and deploy, head to [balenaHub](https://hub.balena.io/blocks)!


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.balena.io/learn/more/examples/balenablocks.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
